/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//
//	FileName	lcd.c
//	Version		1.00
//	MCU		R8C/M12A
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2010/06/04	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	LCDɕ\邽߂̃vOłB
//-------------------------------------------------------------------------------------------------
///////////////////////////////////////////////////////////////////////////////////////////////////
/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2010

*/
///////////////////////////////////////////////////////////////////////////////////////////////////
/* wb_[t@C̃CN[h錾 */
#include "SFR.h"
#include "LCD.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ϐ錾 */

unsigned int x, y;

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD */

void Init_LCD ( void )
{
	/*f[^oXALowŏ*/
	LCD_DB_OUTPUT(0);	// DB Low set
	LCD_E_Low;	// E  Low set
	LCD_RS_Low;	// RS Low set

	Wait_LCD ( 2000 );/*20ms*/

	LCD_RS_Low;		// RS Low Set

	/* LCD1 */
	LCD_E_High;			// E High Set
	LCD_DB_OUTPUT(0x03);	// MM1
	Wait_LCD ( 4 );/*40us*/
	LCD_E_Low;		// E Low Set
	Wait_LCD ( 4 );/*40us*/
	Wait_LCD ( 500 );/*5ms*/

	/* LCD2 */
	LCD_E_High;			// E High Set
	LCD_DB_OUTPUT(0x03);	// MM2
	Wait_LCD ( 4 );/*40us*/
	LCD_E_Low;		// E Low Set
	Wait_LCD ( 4 );/*40us*/
	Wait_LCD ( 10 );/*100us*/

	/* LCD3 */
	LCD_E_High;			// E High Set
	LCD_DB_OUTPUT(0x03);	// MM3
	Wait_LCD ( 4 );/*40us*/
	LCD_E_Low;		// E Low Set
	Wait_LCD ( 4 );/*40us*/

	/* LCD4 */
	LCD_E_High;			// E High Set
	LCD_DB_OUTPUT(0x02);	// MM4
	Wait_LCD ( 4 );/*40us*/
	LCD_E_Low;		// E Low Set
	Wait_LCD ( 4 );/*40us*/

	/* t@NVZbgF4rbgoXA2sA5~7hbg */
	Write_LCD ( 0 , 0x28 );

	/* Gg[[hFJ[\CNgAJ[\ړ */
	Write_LCD ( 0 , 0x06 );

	/* J[\/\VtgFJ[\EVtg */
	Write_LCD ( 0 , 0x10 );

	/* \ON/OFFRg[FfBXvC\AJ[\\AuN\ */
	Write_LCD ( 0 , 0x0c );

	/* \NA */
	Clear_LCD ();

	Wait_LCD ( 5 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD\ */

void Write_LCD (
	const unsigned char RS_Mode ,
	const unsigned char Data
)
{
	/* 4rbg̏ꍇ */
	/* RS Setting */
	if ( RS_Mode == 0 )
	{
		LCD_RS_Low;	// RS Low Set
	}
	else if ( RS_Mode == 1 )
	{
		LCD_RS_High;		// RS High Set
	}

	/* 4rbg */
	LCD_E_High;			// E High Set

	LCD_DB_OUTPUT(( Data >> 4 ) & 0x0f );	// 4rbg
	Wait_LCD ( 4 );/*40us*/
	LCD_E_Low;		// E Low Set
	Wait_LCD ( 4 );/*40us*/

	/* 4rbg */
	LCD_E_High;			// E High Set

	LCD_DB_OUTPUT((  Data & 0x0f ));		// 4rbg
	Wait_LCD ( 4 );/*40us*/
	LCD_E_Low;		// E Low Set
	Wait_LCD ( 4 );/*40us*/
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD J[\ړ */
	
void Locate_LCD ( const unsigned char X, const unsigned char Y )
{
	unsigned char i;
	i = Y * 0x40 + X;
	i = i | 0x80;

	Write_LCD( 0 , i );

	/* J[\ۑ */
	x = X;
	y = Y;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD NA\ */
	
void Clear_LCD ( void )
{
	Write_LCD ( 0 , 0x01 );
	Wait_LCD ( 200 );/*2ms*/
	Locate_LCD ( 0 , 0 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EFCgLCD */
/* for1cycle̓AZu16Xe[gx̏   */
/* g5MHzȉ̌vZwaitZo            */
/* 5MHz  0.2us/state  3.2us/cycle  10us/Interval */
/* wait = Interval * 10us                        */

void Wait_LCD ( const unsigned long Interval )
{
	volatile unsigned long i=Interval;
	for ( i = 0; i < Interval * 3; ++i );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD\ */

void Print_LCD ( const char *String )
{
	unsigned char i, j;
	
	/* \[v */
	for ( i = 0; String[ i ] != '\0'; ++i )
	{
		/* ` */
		if (
			( String[ i ] >= 0x20 && String[ i ] <= 0x7f ) ||
			( String[ i ] >= 0xa1 && String[ i ] <= 0xfd )
		)
		{/* kbcR[h͈͓̔̏ꍇ */
			/* ` */
			Write_LCD ( 1, String[ i ] );
			Wait_LCD ( 1 );
			
		/* J[\ړ */
			if ( x ==  16 - 1 )
			{/* 16sI[o[ꍇ */
				x = 0;
				y = ( y == 0 ? 1 : 0 );
				Locate_LCD ( x, y );
			}
			else
			{/* 16sȓ̏ꍇ */
				++x;
				Locate_LCD ( x, y );
			}
		}
		else if ( String[ i ] == '\n' )
		{/* sR[h̏ꍇ */
			x = 0;
			y = ( y == 0 ? 1 : 0 );
			Locate_LCD ( x, y );
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
